SystemOrganization addCategory: #MiVillanoObjetoso!

Object subclass: #Arma
	instanceVariableNames: 'nombre potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Arma methodsFor: 'accessing' stamp: 'MaxiC 10/23/2014 15:10'!
nombre
	^ nombre! !

!Arma methodsFor: 'accessing' stamp: 'MaxiC 10/23/2014 15:10'!
nombre: anObject
	nombre := anObject! !

!Arma methodsFor: 'accessing' stamp: 'MaxiC 10/23/2014 15:10'!
potencia
	^ potencia! !

!Arma methodsFor: 'accessing' stamp: 'MaxiC 10/23/2014 15:10'!
potencia: anObject
	potencia := anObject! !

Object subclass: #Ciudad
	instanceVariableNames: 'temperatura objetos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Ciudad methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 15:16'!
bajarTemperatura: valor
temperatura := temperatura - valor.! !

!Ciudad methodsFor: 'as yet unclassified' stamp: 'MaxiasdCantarell 10/23/2014 22:31'!
cantidadDeObjetos
^objetos size.! !

!Ciudad methodsFor: 'as yet unclassified' stamp: 'MaxiasdCantarell 10/23/2014 22:39'!
initialize
objetos := Set new.
! !

!Ciudad methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 15:16'!
meRobaron: objeto

objetos remove: objeto.! !

!Ciudad methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 15:13'!
temperatura: valor
temperatura := valor.! !

Object subclass: #Luna
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Luna methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:05'!
condicion: unMinion
^(unMinion poseeArma: 'rayo encogedor').! !

!Luna methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:09'!
premiarMinion: unMinion
|arma|
arma := Arma new.
arma nombre: 'rayo congelante'.
arma potencia: 10.

unMinion otorgarArma: arma.! !

Object subclass: #Maldad
	instanceVariableNames: 'minionsCapacitados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

Maldad subclass: #Congelar
	instanceVariableNames: 'concentracionRequerida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Congelar methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:34'!
agregarMinions: minions 
|tenerRayoCongelante concentracionNecesaria |
tenerRayoCongelante := [:minion |^ minion poseeArma: 'rayo congelante' ].
concentracionNecesaria := [:minion |^ minion nivelDeConcentracion = concentracionRequerida ].

minionsCapacitados := minions select:[:minion | tenerRayoCongelante value: minion & concentracionNecesaria value: minion].! !

!Congelar methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:19'!
cargarConcentracionRequerida: valor
concentracionRequerida := valor.! !

!Congelar methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:25'!
congelar: ciudad
ciudad bajarTemperatura: 30.
self premiarMinions.! !

!Congelar methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:23'!
premiarMinions
minionsCapacitados do:[:minion | minion alimentar: 10 ].! !

!Maldad methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:43'!
dameLosMinions

^minionsCapacitados .! !

!Maldad methodsFor: 'as yet unclassified' stamp: 'MaxiasdCantarell 10/23/2014 22:40'!
initialize
minionsCapacitados := Set new.! !

Maldad subclass: #Robo
	instanceVariableNames: 'objetivo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Robo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:39'!
agregarMinions: minions
minionsCapacitados := minions select:[:minion | objetivo condicion: minion].! !

!Robo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:36'!
cargarObjetivo: unObjetivo 
objetivo := unObjetivo.! !

!Robo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:38'!
premiarMinions
minionsCapacitados do:[:minion | objetivo premiarMinion: minion].! !

!Robo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:40'!
robar: ciudad
ciudad meRobaron: objetivo.! !

Object subclass: #Minion
	instanceVariableNames: 'tipo banana armas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:12'!
alimentar: bananas
banana := banana + bananas.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:19'!
armaMasPotente

^ armas detectMax:[:arma | arma potencia].! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:05'!
cantidadDeArmas

^ armas size.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:20'!
cantidadDeBananas

^banana.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:16'!
esPeligroso
^tipo esPeligroso.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:16'!
nivelDeConcentracion

^ tipo concentracion.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:56'!
otorgarArma: unArma

armas add: unArma.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:09'!
perderArmas

armas removeAll.! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:09'!
tipo: unTipo

tipo := unTipo .! !

!Minion methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:17'!
tomarSuero

tipo tomarSuero.! !

Object subclass: #Piramide
	instanceVariableNames: 'altura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Piramide methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:10'!
altura: valor
altura := valor.! !

!Piramide methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:12'!
condicion: unMinion
^  (unMinion nivelDeConcentracion) >= (altura / 2 ).! !

!Piramide methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:13'!
premiarMinion: unMinion
unMinion alimentar: 10.! !

Object subclass: #SueroMutante
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!SueroMutante methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:15'!
condicion: unMinion
^ (unMinion bienAlimentado & unMinion nivelDeConcentracion >= 23 ).! !

!SueroMutante methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:16'!
premiarMinion: unMinion
unMinion tomarSuero.! !

Object subclass: #Tipo
	instanceVariableNames: 'minion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

Tipo subclass: #Amarillo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Amarillo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:21'!
concentracion

^( (minion armaMasPotente) potencia + minion cantidadDeBananas ).! !

!Amarillo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:05'!
esPeligroso

^ minion cantidadDeArmas > 2.! !

!Amarillo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:09'!
tomarSuero
|violeta|

violeta := Violeta new.
violeta vincularCon: minion.

minion perderArmas.
minion alimentar: -1.
minion tipo: violeta.! !

!Tipo methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:03'!
vincularCon: unMinion

minion := unMinion.! !

Tipo subclass: #Violeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Violeta methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:21'!
concentracion

^(minion cantidadDeBananas ).! !

!Violeta methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:10'!
esPeligroso

^true.! !

!Violeta methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:13'!
tomarSuero
|amarillo|

amarillo := Amarillo new.
amarillo vincularCon: minion.

minion alimentar: -1.
minion tipo: amarillo.! !

Object subclass: #Villano
	instanceVariableNames: 'minions ciudad maldades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoObjetoso'!

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:52'!
agregarCiudad: unaCiudad 

ciudad := unaCiudad.! !

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 16:52'!
agregarMaldad: unaMaldad

maldades add: unaMaldad.! !

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiasdCantarell 10/23/2014 22:39'!
initialize
minions := Set new.
maldades := Set new.! !

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:15'!
nuevoMinion
|minion arma amarillo|

arma:= Arma new.
arma nombre: 'rayo congelante'.
arma potencia: 10.

minion := Minion new.
minion alimentar: 10.
minion otorgarArma: arma.

amarillo := Amarillo new.
amarillo vincularCon: minion.

minion tipo: amarillo.

minions add: minion.! !

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:57'!
obtenerLosMinionsMasInutiles
| minionsEnTodasLasMaldades cantidadDeMaldadesPerpetradas |

minionsEnTodasLasMaldades := Bag new.

minionsEnTodasLasMaldades gather:[:maldad | maldad dameLosMinions].

cantidadDeMaldadesPerpetradas := [:minion | ^minionsEnTodasLasMaldades occurrencesOf: minion].

^minions select:[:minion | cantidadDeMaldadesPerpetradas value: minion = 0].! !

!Villano methodsFor: 'as yet unclassified' stamp: 'MaxiC 10/23/2014 17:54'!
obtenerMinionMasUtil
| minionsEnTodasLasMaldades cantidadDeMaldadesPerpetradas |

minionsEnTodasLasMaldades := Bag new.

minionsEnTodasLasMaldades gather:[:maldad | maldad dameLosMinions].

cantidadDeMaldadesPerpetradas := [:minion | ^minionsEnTodasLasMaldades occurrencesOf: minion].

^minions detectMax:[:minion | cantidadDeMaldadesPerpetradas value: minion ].! !
